scala.tools.nsc.backend.jvm.opt

# BytecodeUtils

###
Related Doc: package opt

#### object BytecodeUtils

Source
  BytecodeUtils.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BytecodeUtils
2. AnyRef
3. Any

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### implicit final class AnalyzerExtensions [V <: Value] extends AnyVal

2. #### class AsmAnalyzer [V <: Value] extends AnyRef

   A wrapper to make ASM's Analyzer a bit easier to use.

3. #### implicit final class FrameExtensions [V <: Value] extends AnyVal

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### object ConditionalJump

5. #### object Goto

6. #### object JumpNonJsr

7. #### object VarInstruction

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def cloneInstructions(methodNode: MethodNode, labelMap: Map[LabelNode, LabelNode]): (InsnList, Map[AbstractInsnNode, AbstractInsnNode])

    Clone the instructions in `methodNode` into a new InsnList, mapping labels according to the `labelMap`.

    Clone the instructions in `methodNode` into a new InsnList, mapping labels according to the `labelMap`. Returns the new instruction list and a map from old to new instructions.

11. #### def cloneLabels(methodNode: MethodNode): Map[LabelNode, LabelNode]

12. #### def cloneLocalVariableNodes(methodNode: MethodNode, labelMap: Map[LabelNode, LabelNode], prefix: String): List[LocalVariableNode]

    Clone the local variable descriptors of `methodNode` and map their `start` and `end` labels according to the `labelMap`.

13. #### def cloneTryCatchBlockNodes(methodNode: MethodNode, labelMap: Map[LabelNode, LabelNode]): List[TryCatchBlockNode]

    Clone the local try/catch blocks of `methodNode` and map their `start` and `end` and `handler` labels according to the `labelMap`.

14. #### def codeSizeOKForInlining(caller: MethodNode, callee: MethodNode): Boolean

15. #### def computeMaxLocalsMaxStack(method: MethodNode): Unit

    In order to run an Analyzer, the maxLocals / maxStack fields need to be available.

    In order to run an Analyzer, the maxLocals / maxStack fields need to be available. The ASM framework only computes these values during bytecode generation.

    Since there's currently no better way, we run a bytecode generator on the method and extract the computed values. This required changes to the ASM codebase:

    - the MethodWriter class was made public
    - accessors for maxLocals / maxStack were added to the MethodWriter class

    We could probably make this faster (and allocate less memory) by hacking the ASM framework more: create a subclass of MethodWriter with a /dev/null byteVector. Another option would be to create a separate visitor for computing those values, duplicating the functionality from the MethodWriter.

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

18. #### def finalJumpTarget(source: JumpInsnNode): LabelNode

19. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

20. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### def getPop(size: Int): InsnNode

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### def instructionResultSize(instruction: AbstractInsnNode): Int

24. #### def isAbstractMethod(methodNode: MethodNode): Boolean

25. #### def isConditionalJump(instruction: AbstractInsnNode): Boolean

26. #### def isConstructor(methodNode: MethodNode): Boolean

27. #### def isExecutable(instruction: AbstractInsnNode): Boolean

28. #### def isFinalClass(classNode: ClassNode): Boolean

29. #### def isFinalMethod(methodNode: MethodNode): Boolean

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### def isJumpNonJsr(instruction: AbstractInsnNode): Boolean

32. #### def isNativeMethod(methodNode: MethodNode): Boolean

33. #### def isReturn(instruction: AbstractInsnNode): Boolean

34. #### def isStaticMethod(methodNode: MethodNode): Boolean

35. #### def isStrictfpMethod(methodNode: MethodNode): Boolean

36. #### def isSynchronizedMethod(methodNode: MethodNode): Boolean

37. #### def isVarInstruction(instruction: AbstractInsnNode): Boolean

38. #### def labelReferences(method: MethodNode): Map[LabelNode, Set[AnyRef]]

39. #### final val maxJVMMethodSize: Int(65535)

40. #### final val maxMethodSizeAfterInline: Int

41. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

42. #### def negateJumpOpcode(jumpOpcode: Int): Int

43. #### def newLabelNode: LabelNode

    Create a new LabelNode with a correctly associated Label.

44. #### def nextExecutableInstruction(instruction: AbstractInsnNode, alsoKeep: (AbstractInsnNode) ⇒ Boolean = Set()): Option[AbstractInsnNode]

45. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

46. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

47. #### def removeJumpAndAdjustStack(method: MethodNode, jump: JumpInsnNode): Unit

48. #### def removeLineNumberNodes(instructions: InsnList): Unit

49. #### def removeLineNumberNodes(classNode: ClassNode): Unit

50. #### def sameTargetExecutableInstruction(a: JumpInsnNode, b: JumpInsnNode): Boolean

51. #### def substituteLabel(reference: AnyRef, from: LabelNode, to: LabelNode): Unit

52. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

53. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

54. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

55. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

56. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from AnyRef

### Inherited from Any

### Ungrouped